;**************************************************************************
;*           Long Windows 95 file names for QB/QBX/VBDOS programs         *
;*                            assembler module                            *
;*                     (c) Hans Lunsing - 11/1996                         *
;**************************************************************************

; Assemble with Microsoft Macro Assembler version 6.0
; with
; /DFARS to compile for far strings (PDS BC /fs, QBX and VBDOS)
; /DNEARS to compile for near strings with PDS BC without /fs
; /DQNEAR to compile for near strings with QB 4.x

.MODEL medium,basic

IFDEF FARS
  ECHO Compiling for far strings...
ELSEIFDEF NEARS
  ECHO Compiling for near strings in BC 7.1...
ELSEIFDEF QNEAR
  ECHO Compiling for near strings in QB 4.x...
ELSE
  .ERR <Compile with /D[FARS|NEARS|QNEAR]>
ENDIF

; Access modes:
OPEN_ACCESS_READONLY            EQU     0
OPEN_ACCESS_WRITEONLY           EQU     1
OPEN_ACCESS_READWRITE           EQU     2
OPEN_ACCESS_RONOMODLASTACCESS   EQU     4

; Sharing modes:
OPEN_SHARE_COMPATIBLE           EQU     0
OPEN_SHARE_DENYREADWRITE        EQU    10h
OPEN_SHARE_DENYWRITE            EQU    20h
OPEN_SHARE_DENYREAD             EQU    30h
OPEN_SHARE_DENYNONE             EQU    40h

; Flags:
OPEN_FLAGS_NOINHERIT            EQU    80h
OPEN_FLAGS_NO_BUFFERING         EQU   100h
OPEN_FLAGS_NO_COMPRESS          EQU   200h
OPEN_FLAGS_ALIAS_HINT           EQU   400h
OPEN_FLAGS_NOCRITERR            EQU  2000h
OPEN_FLAGS_COMMIT               EQU  4000h

; Attributes:
FILE_ATTRIBUTE_NORMAL           EQU     0
FILE_ATTRIBUTE_READONLY         EQU     1
FILE_ATTRIBUTE_HIDDEN           EQU     2
FILE_ATTRIBUTE_SYSTEM           EQU     4
FILE_ATTRIBUTE_VOLUME           EQU     8
FILE_ATTRIBUTE_DIRECTORY        EQU    10h
FILE_ATTRIBUTE_ARCHIVE          EQU    20h

FILE_ATTRIBUTE_ALL              EQU  FILE_ATTRIBUTE_NORMAL \
                                   + FILE_ATTRIBUTE_READONLY \
                                   + FILE_ATTRIBUTE_HIDDEN \
                                   + FILE_ATTRIBUTE_SYSTEM \
                                   + FILE_ATTRIBUTE_ARCHIVE
FILE_ATTRIBUTE_READWRITE        EQU  FILE_ATTRIBUTE_NORMAL \
                                   + FILE_ATTRIBUTE_HIDDEN \
                                   + FILE_ATTRIBUTE_SYSTEM \
                                   + FILE_ATTRIBUTE_ARCHIVE

; Actions for file handling:
FILE_CREATE                     EQU    10h
FILE_OPEN                       EQU     1
FILE_TRUNCATE                   EQU     2

; Maximum path length
MAX_PATH                        EQU     260

;----------------------------------------------------------------------
.DATA

LfnEnabled      DW      0               ; flag telling if Long File Names
                                        ; are enabled already or not
LfnSupport      DW      0               ; flag telling if Long File Names
                                        ; are supported (1 = supported,
                                        ; -1 = not supported)

SystemName      DB      8 dup(0)
LenSysName      EQU     $ - SystemName
Rootname        DB      'C:\', 0

StrDescr        DD      0               ; string descriptor

;----------------------------------------------------------------------
.CODE

; Macro to load BASIC strings

IFDEF FARS

                ; Get far string address and length given a pointer to its
                ; descriptor

LoadString      MACRO sgmnt, reg, ptr
                IFDIFI <ptr>, <si>      ;;if ptr is not SI,
                IFDIFI <reg>, <si>      ;;  and reg is not SI
                  PUSH  SI              ;;  save SI
                ENDIF
                  MOV   SI, ptr         ;;  move ptr to SI
                ENDIF
                PUSH    SI              ;;near offset string descriptor for
                                        ;;  call if StringAddress
                CALL    StringAddress   ;;get address

                PUSH    DX              ;;temporarily save segment and offset
                PUSH    AX              ;;  on stack

                PUSH    SI              ;;near offset string descriptor for
                                        ;;  call of StringLength
                CALL    StringLength    ;;get length
                MOV     CX, AX          ;;place length in CX

                POP     reg             ;;pop string segment and offset
                POP     sgmnt           ;;  in sgmnt:reg

                IFDIFI <ptr>, <si>      ;;if ptr is not SI
                IFDIFI <reg>, <si>      ;;  and reg is not SI
                  POP  SI               ;;  restore SI
                ENDIF
                ENDIF
                ENDM

                ; Create a far string of given length and filled with a
                ; given ascii character and return its address, given a
                ; pointer to a string descriptor

CreateString    MACRO sgmnt, reg, ptr, leng, value
                ;;at entrance DS must point to DGROUP!
                IFDIFI <ptr>, <si>      ;;if ptr is not SI,
                IFDIFI <reg>, <si>      ;;  and reg is not SI
                  PUSH  SI              ;;  save SI
                ENDIF
                  MOV   SI, ptr         ;;  move ptr to SI
                ENDIF
                PUSH    leng            ;;push length
                PUSH    value           ;;push ASCII value
                CALL    B$STRI          ;;returns offset temp. descriptor in AX
                PUSH    AX              ;;push temporary descriptor as source
                PUSH    SI              ;;push our descriptor as destination
                CALL    B$SASS          ;;and create string
                PUSH    SI              ;;push descriptor to get StringAddress
                CALL    StringAddress   ;;get string address
                IFDIFI <reg>, <ax>
                  MOV   reg, AX         ;;move string offset to reg
                ENDIF
                IFDIFI <sgmnt>, <dx>
                  MOV   sgmnt, DX       ;;  and string segment to sgmnt
                ENDIF
                IFDIFI <ptr>, <si>      ;;if ptr is not SI
                IFDIFI <reg>, <si>      ;;  and reg is not SI
                  POP  SI               ;;  restore SI
                ENDIF
                ENDIF
                ENDM

ELSE

                ; Get near string address and length given a pointer to its
                ; descriptor

LoadString      MACRO sgmnt, reg, ptr
                IFIDNI <sgmnt>, <es>    ;;if sgmnt is ES,
                  PUSH  DS              ;;  ensure ES points to
                  POP   ES              ;;  same segment as DS
                ELSEIFDIFI <sgmnt>, <ds>;;if sgmnt is not DS
                  MOV   sgmnt, DS       ;;  make it equal to DS
                ENDIF
                IFDIFI <ptr>, <si>      ;;if ptr is not SI,
                IFDIFI <reg>, <si>      ;;  and reg is not SI
                  PUSH  SI              ;;  save SI
                ENDIF
                  MOV   SI, ptr         ;;  move ptr to SI
                ENDIF
                MOV     CX, [SI]        ;;place length in CX
                MOV     reg, [SI+2]     ;;place string address in <reg>
                IFDIFI <ptr>, <si>      ;;if ptr is not SI
                IFDIFI <reg>, <si>      ;;  and reg is not SI
                  POP  SI               ;;  restore SI
                ENDIF
                ENDIF
                ENDM

                ; Create a near string of given length and filled with a
                ; given ascii character and return its address, given a
                ; pointer to a string descriptor

CreateString    MACRO sgmnt, reg, ptr, leng, value
                PUSH    ptr             ;;save pointer to string descriptor
                PUSH    leng            ;;push length
                PUSH    value           ;;push ASCII value
                CALL    B$STRI          ;;returns offset temp. descriptor in AX
                POP     ptr             ;;retrieve our string descriptor
                PUSH    ptr             ;;and save it again
                PUSH    AX              ;;push temporary descriptor as source
                PUSH    ptr             ;;push our descriptor as destination
                CALL    B$SASS          ;;and create string
                POP     ptr             ;;retrieve offset of our descriptor
                MOV     reg, [ptr+2]    ;;get pointer to string
                IFIDNI <sgmnt>, <es>    ;;if segment is ES,
                  push    ds            ;;ensure ES points to
                  pop     es            ;;same segment as DS
                ELSEIFDIFI <sgmnt>, <ds>
                  MOV   sgmnt, DS       ;;  make it equal to DS
                ENDIF
                ENDM

ENDIF

EXTRN           B_ONEXIT:PROC, \
                B$STRI:PROC, \
                B$SASS:PROC
IFDEF FARS
EXTRN           StringAddress:PROC, \
                StringLength:PROC
ENDIF

OldInt21        DD  0FFFFFFFFh          ; old Int21 vector
LongFileName    DB  MAX_PATH dup(0)     ; room for long file name with
                                        ; OPEN, BLOAD and BSAVE

;----------------------------------------------------------------------
; Int21: the DOS interrupt procedure
;----------------------------------------------------------------------

Int21           PROC    FAR

                PUSHF                   ; save caller's flags
                STI                     ; enable interrupts

                CMP     AH, 71h         ; Win95 long file name functions
                                        ; directly forwarded to DOS
		JE      I21_Jmp

; N.B. The functions
;       7147h (get active directory) and
;       7160h (get full path name)
; are not included, because the caller generally will have declared a
; buffer too small for Windows 95 long file names

                CMP     AH, 39h         ; make subdirectory
                JE      I21_071

                CMP     AH, 3Ah         ; erase subdirectory
                JE      I21_071

                CMP     AH, 3Bh         ; set actual directory
                JE      I21_071

                CMP     AH, 56h         ; rename file
                JNZ     @F

I21_071:        MOV     AL, AH
                MOV     AH, 71h

                JMP     SHORT I21_Jmp

@@:             CMP     AH, 3Ch         ; create file
                                        ; overwrites existing file
                JE      I21_OpenCreate
                CMP     AH, 3Dh         ; open file
                JE      I21_OpenCreate
                CMP     AH, 5Bh         ; create file
                                        ; fails if file exists already
                JE      I21_OpenCreate

                CMP     AH, 41h         ; delete file
                JE      I21_041

                CMP     AH, 43h         ; get or set file attributes
                JE      I21_043

                CMP     AH, 6Ch         ; extended file open/create
                JE      I21_06C

I21_Jmp:        POPF                    ; restore caller's flags
                CLI                     ; disable interrupts
                JMP     CS:OldInt21

I21_OpenCreate: POPF                    ; restore caller's flags

                PUSH    BX              ; preserve registers
                PUSH    CX
                PUSH    DX
                PUSH    DS
                PUSH    SI
                PUSH    DI
                PUSHF                   ; flags on stack for call of ISR

                ;       DS              ; segment file name is given
                MOV     SI, DX          ; offset file name
                CALL    NEAR PTR SubstLfn ; substitute long file name
                XOR     DI, DI          ; no alias hint

                CMP     AH, 3Dh
                JE      I21_03D

                ; Create file

                MOV     BX, OPEN_ACCESS_READWRITE + OPEN_SHARE_COMPATIBLE
                                        ; access & sharing modes & flags
                ;       CX              ; file attribute is given

                CMP     AH, 3Ch
                JNE     @F
                MOV     DX, FILE_CREATE + FILE_TRUNCATE
                                        ; function 3Ch's action
                JMP     SHORT I21_XOC
@@:
                MOV     DX, FILE_CREATE ; function 5Bh's action
                JMP     SHORT I21_XOC

I21_03D:        ; Open file

                MOV     BL, AL          ; access & sharing modes
                XOR     BH, BH          ; flags
                MOV     CX, FILE_ATTRIBUTE_ALL
                                        ; opens all files
                MOV     DX, FILE_OPEN   ; function 3Dh's action

I21_XOC:        ; Execute interrupt

                MOV     AX, 716Ch       ; Function
                                        ; Flags are on stack already
                CLI                     ; Disable interrupts
                CALL    CS:OldInt21     ; Call original ISR

                POP     DI              ; restore registers
                POP     SI
                POP     DS
                POP     DX
                POP     CX
                POP     BX

                RETF    2               ; return from interrupt with t
                                        ; current flags

I21_041:        ; Delete file

                POPF                    ; restore flags
		PUSH    CX              ; preserve unused registers
		PUSH    DX
		PUSH    DS
		PUSH    SI
                PUSHF                   ; flags on stack for call of ISR
                MOV     CH, FILE_ATTRIBUTE_NORMAL
                                        ; matches all files
                MOV     CL, FILE_ATTRIBUTE_READWRITE
                                        ; doesn't erase read-only files
                XOR     SI, SI          ; wildcards not permitted
                MOV     AX, 7141h       ; function
                CLI                     ; disable interrupts
                CALL    CS:OldInt21     ; call original ISR
                POP     SI
                POP     DS
		POP     DX
		POP     CX
		RETF    2               ; return from interrupt with
                                        ; current flags

I21_043:        ; Get or set file attributes

                POPF                    ; restore flags
                PUSH    BX              ; preserve unused registers
                PUSH    DI
                PUSH    SI
                PUSHF                   ; flags on stack for call of ISR

                AND     AL, 1           ; set or get attributes only
                MOV     BL, AL          ; subfunction
                ;       CX              ; attributes are given
                ;       DX              ; offset file name is given
                ;       DS              ; segment file name is given
                MOV     AX, 7143h       ; function

                CLI                     ; disable interrupts
                CALL    DWORD PTR OldInt21; call original ISR

                POP     SI              ; restore registers
                POP     DI
                POP     BX
                RETF    2               ; return from interrupt with
                                        ; current flags

I21_06C:        ; Extended open/create file

                POPF                    ; restore flags
                PUSH    DI              ; preserve unused registers
                PUSHF                   ; flags on stack for call of ISR
                XOR     DI, DI          ; no alias hint
                MOV     AX, 716Ch       ; function
                CLI                     ; disable interrupts
                CALL    DWORD PTR OldInt21; call original ISR
                POP     DI
                RETF    2               ; return from interrupt with
                                        ; current flags
Int21           ENDP

; Tests if given filename is a CHR$(255) character followed by a period
; only, zero terminated. If that is the case, the file name address in
; DS:SI for the ISR is substituted by the long file name delivered by
; Lfn$, LongFileName. Otherwise the file name address keeps pointing to
; the given file name.

SubstLfn:
                PUSH    AX
                PUSH    CX
                PUSH    ES
                PUSH    DI

                MOV     AX, DS
                MOV     ES, AX
                MOV     DI, SI
                XOR     AL, AL
                MOV     CX, -1
                                        ; QB adds absolute path to file name, so
          REPNZ SCASB                   ; read filename till terminating zero
                SUB     DI, 4           ; go back four places
                PUSH    SI              ; (preserve SI)
                MOV     SI, DI
                LODSB                   ; read a byte
                MOV     CL, AL          ; save it
                LODSW                   ; and read the last two bytes
                POP     SI              ; (restore SI)
                CMP     CL, '\'         ; if the first is "\"
                JNE     @F
                CMP     AX, 02EFFh      ; and the next chr$(255) + "."
                JNE     @F              ; then
                MOV     AX, CS          ; substitute long filename
                MOV     DS, AX
                MOV     SI, OFFSET LongFileName
@@:
                POP     DI
                POP     ES
                POP     CX
                POP     AX
                RET

;----------------------------------------------------------------------
; Function EnableLfn
;
; Basic declare:
; DECLARE FUNCTION EnableLfn% ()
;
; EnableLfn enables the use of long file names with QuickBasic/VBDOS
; statements.
; Returns -1 if Enabled, and 0 otherwise
;----------------------------------------------------------------------

EnableLfn       PROC    FAR

                ; Test if already enabled

                CMP     LfnEnabled, 0
                JE      @F
                MOV     AX, -1
                JMP     SHORT Elfn_Exit

@@:             ; Test if long file names are supported

                CALL    FAR PTR LfnSupported
                CMP     AX, 0
                JE      Elfn_Exit

                ; Save current Int 21h vector in OldInt21

                MOV     AX, 3521h       ;get active Int21 vector in ES:BX
                INT     21h
                PUSH    DI
                MOV     DI, OFFSET OldInt21     ;and save at CS:DI
                MOV     WORD PTR CS:[DI], BX
                MOV     WORD PTR CS:[DI+2], ES
                POP     DI

                ; Give new Int 21 vector Int21 to DOS

                PUSH    DS
                MOV     AX, CS
                MOV     DS, AX
                MOV     DX, OFFSET Int21        ;new vector in DS:DX
                MOV     AX, 2521h
		INT     21h
                POP     DS

                ; Set own interrupt flag

                MOV     AX, -1
                MOV     LfnEnabled, AX

                ; DisableLfn has to be called when the program terminates
                ; (Alternatively one could intercept a function &h4C
                ; request in the Int 21h interrupt handler)

                PUSH    CS
                MOV     AX, OFFSET DisableLfn
                PUSH    AX
                CALL    B_ONEXIT

Elfn_Exit:
                RET
EnableLfn       ENDP

;----------------------------------------------------------------------
; Procedure DisableLfn
;
; Basic declare:
; DECLARE SUB DisableLfn ()
;
; DisableLfn disables the use of long file names with QuickBasic/VBDOS
; statements
;----------------------------------------------------------------------
DisableLfn      PROC    FAR

                ; Test if already disabled

                CMP     LfnEnabled, 0
                JE      Dlfn_Exit

                ; Restore original interrupt vector

                PUSH    DS
                MOV     DX, WORD PTR CS:OldInt21[0]
                MOV     DS, WORD PTR CS:OldInt21[2]
                MOV     AX, 2521h
                INT     21h
                POP     DS

                ; Lower own interrupt flag

                MOV     LfnEnabled, 0
Dlfn_Exit:
                RET
DisableLfn      ENDP

;----------------------------------------------------------------------
; Function LfnSupported
;
; BASIC declaration:
; DECLARE LfnSupported% ()
;
; LfnSupported returns TRUE (-1) if Windows 95 long file names are
; supported, and FALSE (0) otherwise
;----------------------------------------------------------------------
LfnSupported    PROC    FAR

                ; First test if function was called already.
                ; If so, result is in flag LfnSupport

                MOV     DX, LfnSupport
                XOR     AX, AX          ;initialize return value: not supported
                CMP     DX, 0           ;if LfnSupport = 0
                JE      LfnS_Check      ;then yet to check
                JL      @F              ;if LfnSupport > 0
                DEC     AX              ;then lfn's supported
                JMP     SHORT @F

LfnS_Check:     ;Do we have DOS 7 or higher (but not a DOS box under OS/2)?
                ;N.B.: OS/2 version 2's DOS box has version number 20

                XOR     BX, BX          ;Zero BX
                MOV     AX, 3306h       ;get DOS version (5 or higher)
                INT     21h
                CMP     BL, 7           ;If BL is 5 or 6 (DOS version)
                                        ;or 0 (DOS 4 or lower), then
                JB      lNoLongNames    ;no long names
                CMP     BL, 19          ;If BL 20 or higher (OS/2), then
                JA      lNoLongNames    ;no long Win95 names

                ;DO we have MSDOS 7?

                PUSH    DS
                MOV     AX, 4A33h       ;function 4A33h
                INT     2Fh             ;of ISR 2Fh
                POP     DS
                CMP     AX, 0           ;is AX 0 zeroed?
                JNE     lNoLongNames    ;if not, no MS-DOS 7

                ;Does system support long names?

                PUSH    ES
                PUSH    DI
                MOV     DI, DS          ;get address of SystemName in ES:DI
                MOV     ES, DI
                MOV     DI, OFFSET SystemName
                MOV     CX, LenSysName  ; and length in CX
                                        ; get address of RootName in DS:DX
                MOV     DX, OFFSET RootName
                MOV     AX, 71A0h       ;get volume information
                INT     21h
                POP     DI
                POP     ES
                MOV     AX, -1
                JNC     @F
lNoLongNames:
                XOR     AX, AX
@@:             RET
LfnSupported    ENDP

;----------------------------------------------------------------------
; Function Lfn
;
; Basic declaration:
; DECLARE FUNCTION Lfn$ (LongFName AS STRING)
;
; Returns CHR$(255) + "." if long filenames are enabled, or the
; filename given as parameter otherwise. The extension period is
; necessary for BSAVE/BLOAD, because otherwise an extension of
; .BAS is supplied by those procedures
;----------------------------------------------------------------------

Lfn             PROC    USES ES SI, LongFName:PTR

                ; For QB it isn't really necessary to preserve the
                ; default data segment because all string are in the
                ; default data segment. I have done it here for
                ; portability of code.

                LOCAL   DataSeg:WORD

                MOV     DataSeg, DS     ; preserve data segment DGROUP

                ; Load name string in DX:SI and its length in CX
                ; Don't point DS to the string segment right away to
                ; be able to easily access the variable LfnEnabled

                LoadString DX, SI, LongFName
                CMP     LfnEnabled, 0
                MOV     DS, DX          ; let DS point to string segment
                JE      Lfn_Disabled
Lfn_Enabled:
                ; Place name string in LongFileName

                MOV     AX, MAX_PATH
                CMP     CX, AX          ; length <= MAX_PATH?
                JBE     @F              ; if not,
                MOV     CX, AX          ; truncate string to max. length
@@:             MOV     AX, CS
                MOV     ES, AX
                MOV     DI, OFFSET LongFileName
           REP  MOVSB
                XOR     AL, AL
                STOSB                   ; and terminate string with zero

                ; Make new string of length two with ASCII value 255

                MOV     DS, DataSeg     ; let DS point to DGROUP
                MOV     AX, 0FFh        ; chr$(255)
                MOV     CX, 2           ; length
                MOV     BX, OFFSET StrDescr     ; pointer to descriptor
                PUSH    SI
                CreateString DS, SI, BX, CX, AX
                MOV     BYTE PTR [SI+1], '.' ; change 2nd byte to period
                POP     SI
                JMP     SHORT Lfn_Exit
Lfn_Disabled:
                ; Make new string and copy given file name to it

                PUSH    DS              ; preserve source string segment
                MOV     DS, DataSeg     ; let DS point to DGROUP
                XOR     AX, AX          ; fill string with zero's
                ;       CX              ; length already given
                MOV     BX, OFFSET StrDescr     ; pointer to descriptor
                CreateString ES, DI, BX, CX, AX ; create string
                POP     DS              ; get source string segment
           REP  MOVSB                   ; and copy the given file name

Lfn_Exit:
                MOV     DS, DataSeg     ; restore data segment to DGROUP
                MOV     AX, OFFSET StrDescr     ; return offset of descriptor
                RET
Lfn             ENDP

;----------------------------------------------------------------------
; Function SSEG
;
; Basic declaration:
; DECLARE FUNCTION SSEG% (SomeString AS STRING)
;
; Returns the default data segment being every string's segment in QB 4.5.
; The function is a placeholder for QBX's and VBDOS's SSEG function.
;----------------------------------------------------------------------

IFDEF QNEAR
SSEG            PROC    FAR

                MOV     AX, DS
                RETF    2
SSEG            ENDP
ENDIF

                END

