' MBLfn.bi
'******************************************************************************
DEFINT A-Z

'************** Declarations of constants *************************************

CONST FALSE = 0
CONST TRUE = NOT FALSE

' Access modes:
CONST OPEN.ACCESS.READONLY = 0
CONST OPEN.ACCESS.WRITEONLY = 1
CONST OPEN.ACCESS.READWRITE = 2
CONST OPEN.ACCESS.RONOMODLASTACCESS = 4

' Sharing modes:
CONST OPEN.SHARE.COMPATIBLE = 0
CONST OPEN.SHARE.DENYREADWRITE = &H10
CONST OPEN.SHARE.DENYWRITE = &H20
CONST OPEN.SHARE.DENYREAD = &H30
CONST OPEN.SHARE.DENYNONE = &H40

' Flags:
CONST OPEN.FLAGS.NOINHERIT = &H80
CONST OPEN.FLAGS.NO.BUFFERING = &H100
CONST OPEN.FLAGS.NO.COMPRESS = &H200
CONST OPEN.FLAGS.ALIAS.HINT = &H400
CONST OPEN.FLAGS.NOCRITERR = &H2000
CONST OPEN.FLAGS.COMMIT = &H4000

' Attributes:
CONST FILE.ATTRIBUTE.NORMAL = 0
CONST FILE.ATTRIBUTE.READONLY = 1
CONST FILE.ATTRIBUTE.HIDDEN = 2
CONST FILE.ATTRIBUTE.SYSTEM = 4
CONST FILE.ATTRIBUTE.VOLUME = 8
CONST FILE.ATTRIBUTE.DIRECTORY = &H10
CONST FILE.ATTRIBUTE.ARCHIVE = &H20

CONST FILE.ATTRIBUTE.ALL = FILE.ATTRIBUTE.NORMAL + FILE.ATTRIBUTE.READONLY + FILE.ATTRIBUTE.HIDDEN + FILE.ATTRIBUTE.SYSTEM + FILE.ATTRIBUTE.ARCHIVE
CONST FILE.ATTRIBUTE.READWRITE = FILE.ATTRIBUTE.NORMAL + FILE.ATTRIBUTE.HIDDEN + FILE.ATTRIBUTE.SYSTEM + FILE.ATTRIBUTE.ARCHIVE

' Maximum path length
CONST MAXPATH = 260
CONST MAXDOSPATH = 67

'************** Declarations of structured variables **************************

' Win32 structure for file info

TYPE Win32FindData
  dwFileAttributes      AS LONG
  ftCreationTime0       AS LONG
  ftCreationTime1       AS LONG
  ftLastAccessTime0     AS LONG
  ftLastAccessTime1     AS LONG
  ftLastWriteTime0      AS LONG
  ftLastWriteTime1      AS LONG
  nFileSizeHigh         AS LONG
  nFileSizeLow          AS LONG
  dwReserved0           AS LONG
  dwReserved1           AS LONG
  cFileName             AS STRING * MAXPATH
  cAlternateFileName    AS STRING * 14
END TYPE

' DOS structure for file info

TYPE DOSFileInfo
  fiReserved            AS STRING * 21  'for DOS' internal use
  fiAttribute           AS STRING * 1   'file attribute code
  fiFileTime            AS INTEGER      'file time (in DOS format)
  fiFileDate            AS INTEGER      'file date (in DOS format)
  fiSize                AS LONG         'file size (in bytes)
  fiFileName            AS STRING * 13  'file name (without path)
END TYPE

' Register type for use with INTERRUPT

TYPE RegType
     AX    AS INTEGER
     BX    AS INTEGER
     CX    AS INTEGER
     DX    AS INTEGER
     BP    AS INTEGER
     SI    AS INTEGER
     DI    AS INTEGER
     FLAGS AS INTEGER
END TYPE

' Registertype for use with INTERRUPTX

TYPE RegTypeX
     AX    AS INTEGER
     BX    AS INTEGER
     CX    AS INTEGER
     DX    AS INTEGER
     BP    AS INTEGER
     SI    AS INTEGER
     DI    AS INTEGER
     FLAGS AS INTEGER
     DS    AS INTEGER
     ES    AS INTEGER
END TYPE

'**************** FUNCTION and SUB declarations *******************************

DECLARE FUNCTION CurDrive$ ()
DECLARE FUNCTION DOSErr% ()
DECLARE FUNCTION DOSErrTest% ()
DECLARE SUB      DisableLfn ()
DECLARE FUNCTION DiskFree& (Drive AS STRING)
DECLARE FUNCTION EnableLfn% ()
DECLARE SUB      GetFileInfo (FileData AS DOSFileInfo)
DECLARE SUB      GetFindData (FileData AS Win32FindData)
DECLARE FUNCTION GetDriveNumber% (Drive AS STRING)
DECLARE FUNCTION Lfn$ (FileName AS STRING)
DECLARE FUNCTION LfnCurDir$ (Drive AS STRING)
DECLARE FUNCTION LfnDirAlias$ ()
DECLARE FUNCTION LfnDirFirst$ (Mask AS STRING, Attrib AS INTEGER)
DECLARE FUNCTION LfnDirNext$ ()
DECLARE SUB      LfnFiles ()
DECLARE FUNCTION LfnGetAttrib% (FileName AS STRING)
DECLARE SUB      LfnKill (FileName AS STRING)
DECLARE SUB      LfnName (OldName AS STRING, NewName AS STRING)
DECLARE SUB      LfnSetAttrib (FileName AS STRING, Attrib AS INTEGER)
DECLARE FUNCTION LfnSupported% ()

DECLARE SUB      Interrupt (IntNum AS INTEGER, InReg AS RegType, _
                 OutReg AS RegType)
DECLARE SUB      InterruptX (IntNum AS INTEGER, InReg AS RegTypeX, _
	         OutReg AS RegTypeX)

